<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        #{dataTableStateHolder.setDescendingOn('dateReceived')}
        <h:form>
            <h2>#{messages['net.ihe.gazelle.atna.TLSSSLConnection']}</h2>

            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.ConnectionDetails']}</ui:define>

                <dl class="dl-horizontal">

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.proxy.PermanentLink']}</ui:define>
                        <h:outputLink target="_blank"
                                      value="#{connectionView.getPermanentLink(connectionView.connection)}">
                            #{connectionView.getPermanentLink(connectionView.connection)}
                        </h:outputLink>
                    </ui:decorate>

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.ConnectionDate']}</ui:define>
                        <g:date value="#{connectionView.connection.date}"/>
                    </ui:decorate>

                </dl>
                <dl class="dl-horizontal">

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.SUTAddress']}</ui:define>
                        <h:outputText value="#{connectionView.connection.remoteHost}"/>
                        <h:outputText value=":"/>
                        <h:outputText value="#{connectionView.connection.remotePort}"/>
                    </ui:decorate>

                    <h:panelGroup rendered="#{not empty connectionView.connection.peerCertificateChainPEM}">
                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.SUTCertificates']}</ui:define>
                            <rich:list var="cert" value="#{connectionView.certificates}">
                                <h:commandLink rendered="#{cert.id!=null}" value="#{cert.subject}" target="_blank"
                                               action="#{connectionView.redirectToCertificate(cert.id)}"/>
                            </rich:list>
                            <h:outputText rendered="#{connectionView.peerCertificates == null}"
                                          value="#{connectionView.getChain()}" escape="false"
                                          style="font-family: monospace;"/>
                        </ui:decorate>
                    </h:panelGroup>

                </dl>
                <dl class="dl-horizontal">

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.SimulatorAddress']}</ui:define>
                        <h:outputText value="#{connectionView.connection.localHost}"/>
                        <h:outputText value=":"/>
                        <h:outputText value="#{connectionView.connection.localPort}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.SimulatorKeyword']}</ui:define>
                        <h:commandLink action="#{connectionView.redirectToSimulator()}"
                                       value="#{connectionView.connection.simulator.keyword}" target="_blank"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.SimulatorCertificate']}</ui:define>
                        <h:commandLink action="#{connectionView.redirectToCertificate()}"
                                       value="#{connectionView.connection.simulator.certificate.subject}"
                                       target="_blank"/>
                    </ui:decorate>

                </dl>
                <dl class="dl-horizontal">

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.HandshakeSuccess']}</ui:define>
                        <s:span styleClass="gzl-icon-circle-blue" rendered="#{connectionView.connection.success}"
                                title="#{messages['net.ihe.gazelle.atna.HandshakeSucceed']}"></s:span>
                        <s:span styleClass="gzl-icon-circle-red" rendered="#{not connectionView.connection.success}"
                                title="#{messages['net.ihe.gazelle.atna.HandshakeFailed']}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.Protocol']}</ui:define>
                        <h:outputText value="#{connectionView.connection.protocol.name}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.CipherSuite']}</ui:define>
                        <h:outputText value="#{connectionView.connection.cipherSuite}"/>
                    </ui:decorate>

                    <h:panelGroup rendered="#{not empty connectionView.connection.exceptionMessage}">
                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">
                                #{connectionView.getExceptionMessageLabel()}
                                <ui:decorate template="/layout/popover/_popover_on_icon.xhtml">
                                    <ui:param name="id" value="errorMessagePopover"/>
                                    <ui:define name="content">#{messages['net.ihe.gazelle.atna.ThisMessageWasTriggeredByTheSimulator']}</ui:define>
                                </ui:decorate>
                            </ui:define>
                            <s:div styleClass="#{connectionView.getExceptionMessageStyleClass()}">
                                <h:outputText
                                        value="#{connectionView.escape(connectionView.connection.exceptionMessage)}"
                                        escape="false"/>
                            </s:div>
                        </ui:decorate>
                    </h:panelGroup>

                    <h:panelGroup rendered="#{not empty connectionView.connection.exceptionStackTrace}">
                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">
                                #{messages['net.ihe.gazelle.atna.ErrorStackTrace']}
                                <ui:decorate template="/layout/popover/_popover_on_icon.xhtml">
                                    <ui:param name="id" value="errorStackPopover"/>
                                    <ui:define name="content">
                                        #{messages['net.ihe.gazelle.atna.ThisErrorStackTraceWasThrownByTheSimulator']}
                                    </ui:define>
                                </ui:decorate>
                            </ui:define>
                            <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                                <ui:param name="panel_id" value="stackTracePanel"/>
                                <ui:param name="openByDefault" value="false"/>
                                <ui:define name="panel_title">
                                    #{messages['net.ihe.gazelle.atna.ErrorStackTrace']}
                                </ui:define>
                                <h:outputText value="#{connectionView.getError()}" escape="false"
                                              style="font-family: monospace;"/>
                            </ui:decorate>
                        </ui:decorate>
                    </h:panelGroup>

                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.TLSSSLEvents']}</ui:define>

                        <ui:repeat value="#{connectionView.connection.data.items}" var="item" varStatus="loop">
                            <ui:decorate template="/layout/panels/_panel.xhtml">
                                <dl class="dl-horizontal">

                                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Date']}</ui:define>
                                        <h:outputText value="#{item.date}">
                                            <f:convertDateTime pattern="MM/dd/yyyy HH:mm:ss.SSS" type="both"/>
                                        </h:outputText>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.Type']}
                                        </ui:define>
                                        <h:outputText value="#{item.type}"/>
                                    </ui:decorate>
                                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.Details']}</ui:define>
                                        <h:panelGroup rendered="#{not item.aliases}">
                                            <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                                                <ui:param name="panel_id" value="item#{loop.index}DetailPanel"/>
                                                <ui:param name="openByDefault" value="true"/>
                                                <ui:define name="panel_title">
                                                    #{messages['net.ihe.gazelle.atna.Details']}
                                                </ui:define>
                                                <h:outputText value="#{item.authType}"/>
                                                <rich:list value="#{connectionView.parseCertificates(item.pemChain)}"
                                                           var="cert">
                                                    <h:commandLink rendered="#{cert.id!=null}" value="#{cert.subject}"
                                                                   action="#{connectionView.redirectToCertificate(cert.id)}"
                                                                   target="_blank"/>
                                                    <h:panelGroup rendered="#{cert.id==null}">
                                                        <h:outputText value="#{cert.subject}"/>
                                                        <br/>
                                                        <h:outputText value="#{connectionView.getAsString(cert)}"
                                                                      escape="false"
                                                                      style="font-family: monospace;"/>
                                                    </h:panelGroup>
                                                </rich:list>

                                            </ui:decorate>
                                        </h:panelGroup>
                                        <h:panelGroup rendered="#{item.aliases}">
                                            <dl class="dl-horizontal">
                                                <ui:decorate template="/layout/display/_display.xhtml">
                                                    <ui:define name="label">
                                                        #{messages['net.ihe.gazelle.atna.KeyTypes']}
                                                    </ui:define>
                                                    <rich:list value="#{item.keyTypes}" var="keyTypeFromList">
                                                        <h:outputText value="#{keyTypeFromList.value}"/>
                                                    </rich:list>
                                                </ui:decorate>
                                                <h:panelGroup rendered="#{item.issuers.isEmpty()}">
                                                    <ui:decorate template="/layout/display/_display.xhtml">
                                                        <ui:define name="label">
                                                            #{messages['net.ihe.gazelle.atna.Issuers']}
                                                        </ui:define>
                                                        <rich:list value="#{item.issuers}" var="issuerFromList">
                                                            <h:outputText value="#{issuerFromList.value}"/>
                                                        </rich:list>
                                                    </ui:decorate>
                                                </h:panelGroup>
                                            </dl>
                                        </h:panelGroup>
                                    </ui:decorate>

                                </dl>
                            </ui:decorate>
                        </ui:repeat>

                    </ui:decorate>
                </dl>

            </ui:decorate>

            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.InterceptedMessages']}</ui:define>
                <s:div styleClass="gzl-alert-red"
                       rendered="#{not connectionView.isThereConnectionMessages() and connectionView.connection.success}">
                    <p>#{messages['net.ihe.gazelle.atna.NoMessageRecordedThereAre2Possibilities']}</p>
                    <ul>
                        <li>#{messages['net.ihe.gazelle.atna.NoMessageHasBeenSentOr']},</li>
                        <li>#{messages['net.ihe.gazelle.atna.MessagesHaveBeenWellSentReceivedAndorForwardedBu']}
                        </li>
                    </ul>
                </s:div>
                <s:div styleClass="gzl-alert-red"
                       rendered="#{not connectionView.isThereConnectionMessages() and not connectionView.connection.success}">
                    <p>#{messages['net.ihe.gazelle.atna.NoMessagesRecordedTheTLSHandshakeFailed']}</p>
                </s:div>

                <ui:include src="/messageList.xhtml">
                    <ui:param name="messagesList" value="#{connectionView.connectionMessages}"/>
                    <ui:param name="enableFilteringLinks" value="#{false}"/>
                </ui:include>
            </ui:decorate>

        </h:form>
    </ui:define>
</ui:composition>
